﻿Public Class frmWeather
	Private NewDatafolder As String
	Private WeatherLocation As String
	Private ReadOnly _datafolder As String = Path.Combine(Application.StartupPath, "ApSet.xml")

	Private Sub ReadDatafolderFromXml()
		Dim xDoc As XDocument = XDocument.Load(_datafolder)
		' Finde das Element mit dem Namen "dataFolder"
		Dim DatafolderElement As XElement = xDoc.Root.Element("dataFolder")
		Dim LocationElement As XElement = xDoc.Root.Element("location")
		WeatherLocation = CStr(LocationElement)
		If DatafolderElement IsNot Nothing Then
			' Zeige den Inhalt des Elements im TextBox-Steuerelement an
			ToolStripStatusLabel2.Text = "   Speicherort ist: " & DatafolderElement.Value
			NewDatafolder = DatafolderElement.Value & "\"
		Else
			' Zeige eine Fehlermeldung an, wenn das Element nicht gefunden wurde
			MessageBox.Show("Das Element 'dataFolder' konnte nicht gefunden werden.", "Fehler", MessageBoxButtons.OK, MessageBoxIcon.Error)
		End If
	End Sub
	Private Sub DGV_Show_CellFormatting(sender As Object, e As DataGridViewCellFormattingEventArgs) Handles DGV_Show.CellFormatting
		If e.ColumnIndex = 0 AndAlso Not e.Value Is Nothing Then
			e.Value = DateTime.Parse(e.Value.ToString()).ToString("dd-MM-yyyy")
			e.FormattingApplied = True
		End If
		' Überprüfen, ob es sich um eine Zelle mit einer Zahl handelt
		If e.ColumnIndex >= 0 AndAlso IsNumeric(e.Value) Then
			' Überprüfen, ob die Zahl negativ ist
			If CDbl(e.Value) < 0 Then
				' Setzen Sie die Textfarbe auf Rot
				e.CellStyle.ForeColor = Color.Red
			Else
				' Setzen Sie die Textfarbe auf Standardfarbe
				e.CellStyle.ForeColor = DGV_Show.DefaultCellStyle.ForeColor
			End If
		End If
	End Sub

	Private Sub frmWeather_Load(sender As Object, e As EventArgs) Handles MyBase.Load
		Me.DoSomething()
		Me.Text = " WetterApp vers.: 1.5 - Aufzeichnungsort ist: " & WeatherLocation
	End Sub

	Private Sub DoSomething()
		Dim dateValue As DateTime = DateTime.Now
		Dim formattedDate As String = dateValue.ToString("dd.MM.yyyy")
		ToolStripStatusLabel1.Text = formattedDate
		ReadDatafolderFromXml()
		DGV_Show.ColumnHeadersDefaultCellStyle.Font = New Font("Segoe UI", 7)
		'Datum im Format "yyyy-MM" aus dem DTPicker auslesen
		Dim selectedDate As String = dtp_Show.Value.ToString("yyyy-MM")
		'Pfad zur ausgewählten XML-Datei erstellen
		Dim xmlFilePath As String = NewDatafolder & selectedDate & ".xml"
		'Prüfen, ob die XML-Datei existiert und sie laden
		If File.Exists(xmlFilePath) Then
			Dim dt As New DataTable()
			Dim ds As New DataSet()
			ds.ReadXml(xmlFilePath)
			If ds.Tables.Count > 0 Then
				dt = ds.Tables(0)
				'Ändere die Spaltenbezeichnungen auf das gewünschte Format
				dt.Columns("Datum").ColumnName = "Datum"
				dt.Columns("WetterNacht").ColumnName = "Wetterkürzel" & Environment.NewLine & "Nacht"
				dt.Columns("WetterTag").ColumnName = "Wetterkürzel" & Environment.NewLine & "Tag"
				'dt.Columns("RegenNacht").ColumnName = "Regen" & Environment.NewLine & "Nacht"
				dt.Columns("RegenTag").ColumnName = "Regen" & Environment.NewLine & "Tag"
				dt.Columns("SchneeNacht").ColumnName = "Schnee" & Environment.NewLine & "Nacht"
				dt.Columns("SchneeTag").ColumnName = "Schnee" & Environment.NewLine & "Tag"
				dt.Columns("LuftfminNacht").ColumnName = "Luftfeuchte" & Environment.NewLine & "min Nacht"
				dt.Columns("LuftfmaxNacht").ColumnName = "Luftfeuchte" & Environment.NewLine & "max Nacht"
				dt.Columns("LuftfminTag").ColumnName = "Luftfeuchte" & Environment.NewLine & "min Tag"
				dt.Columns("LuftfmaxTag").ColumnName = "Luftfeuchte" & Environment.NewLine & "max Tag"
				dt.Columns("TempNacht").ColumnName = "Temperatur" & Environment.NewLine & "Nacht"
				dt.Columns("TempTag").ColumnName = "Temperatur" & Environment.NewLine & "Tag"
				dt.Columns("WindNacht").ColumnName = "Windstärke" & Environment.NewLine & "Nacht"
				dt.Columns("WindTag").ColumnName = "Windstärke" & Environment.NewLine & "Tag"
				'dt.Columns("Luftdruck").ColumnName = "Luftdruck (hPa)"
				'dt.Columns("Windrichtung").ColumnName = "Windrichtung"
				DGV_Show.DataSource = dt
			Else
				MessageBox.Show("Die Datei enthält keine Daten.")
			End If
		Else
			MessageBox.Show("Die Datei " & selectedDate & " konnte nicht gefunden werden.")
		End If
	End Sub

	Private Sub dtp_Show_ValueChanged(sender As Object, e As EventArgs) Handles dtp_Show.ValueChanged
		'Datum im Format "yyyy-MM" aus dem DTPicker auslesen
		Dim selectedDate As String = dtp_Show.Value.ToString("yyyy-MM")
		'Pfad zur ausgewählten XML-Datei erstellen
		Dim xmlFilePath As String = NewDatafolder & selectedDate & ".xml"
		'Prüfen, ob die XML-Datei existiert und sie laden
		If File.Exists(xmlFilePath) Then
			Dim dt As New DataTable()
			Dim ds As New DataSet()
			ds.ReadXml(xmlFilePath)
			If ds.Tables.Count > 0 Then
				dt = ds.Tables(0)
				'Ändere die Spaltenbezeichnungen auf das gewünschte Format
				dt.Columns("Datum").ColumnName = "Datum"
				dt.Columns("WetterNacht").ColumnName = "Wetter" & Environment.NewLine & "Nacht"
				dt.Columns("WetterTag").ColumnName = "Wetter" & Environment.NewLine & "Tag"
				'dt.Columns("RegenNacht").ColumnName = "Regen" & Environment.NewLine & "Nacht"
				dt.Columns("RegenTag").ColumnName = "Regen" & Environment.NewLine & "Tag"
				dt.Columns("SchneeNacht").ColumnName = "Schnee" & Environment.NewLine & "Nacht"
				dt.Columns("SchneeTag").ColumnName = "Schnee" & Environment.NewLine & "Tag"
				dt.Columns("LuftfminNacht").ColumnName = "Luftf min" & Environment.NewLine & "Nacht"
				dt.Columns("LuftfmaxNacht").ColumnName = "Luftf max" & Environment.NewLine & "Nacht"
				dt.Columns("LuftfminTag").ColumnName = "Luftf min" & Environment.NewLine & "Tag"
				dt.Columns("LuftfmaxTag").ColumnName = "Luftf max" & Environment.NewLine & "Tag"
				dt.Columns("TempNacht").ColumnName = "Temp" & Environment.NewLine & "Nacht"
				dt.Columns("TempTag").ColumnName = "Temp" & Environment.NewLine & "Tag"
				dt.Columns("WindNacht").ColumnName = "Wind" & Environment.NewLine & "Nacht"
				dt.Columns("WindTag").ColumnName = "Wind" & Environment.NewLine & "Tag"
				'dt.Columns("Luftdruck").ColumnName = "Luftdruck (hPa)"
				'dt.Columns("Windrichtung").ColumnName = "Windrichtung"
				DGV_Show.DataSource = dt
			Else
				MessageBox.Show("Die Datei enthält keine Daten.")
			End If
		Else
			MessageBox.Show("Die Datei " & selectedDate & ".jmd konnte nicht gefunden werden.")
		End If
	End Sub


	Private Sub DiagrammToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles DiagrammToolStripMenuItem.Click
		frmDiagramm.ShowDialog()
	End Sub

	Private Sub EingabenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EingabenToolStripMenuItem.Click
		frmInput.ShowDialog()
	End Sub

	Private Sub EinstellungenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EinstellungenToolStripMenuItem.Click
		frmSettings.ShowDialog()
	End Sub

	Private Sub InfoToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles InfoToolStripMenuItem.Click

	End Sub

	Private Sub TabelleNeuEinlesenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles TabelleNeuEinlesenToolStripMenuItem.Click
		Me.DoSomething()
	End Sub

	Private Sub DruckenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles DruckenToolStripMenuItem.Click

		Dim printDialog As New PrintDialog()
		Dim printDocument As New Printing.PrintDocument()
		printDialog.Document = printDocument
		printDialog.UseEXDialog = True
		'Einstellungen für den Druckdialog
		printDialog.AllowCurrentPage = False
		printDialog.AllowSelection = False
		printDialog.AllowSomePages = True
		printDialog.PrintToFile = False
		printDialog.ShowHelp = False
		printDialog.ShowNetwork = False
		'Wenn der Benutzer auf OK klickt
		If printDialog.ShowDialog() = DialogResult.OK Then
			printDocument.PrinterSettings = printDialog.PrinterSettings
			AddHandler printDocument.PrintPage, AddressOf PrintDocument_PrintPage
			printDocument.DefaultPageSettings.Landscape = True 'Querformat
			printDocument.Print()
		End If
	End Sub

	Private Sub PrintDGV()
		' Setze den Druckbereich des DataGridViews auf die gesamte Breite des Papiers.
		DGV_Show.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.DisplayedCells
		DGV_Show.Width = DGV_Show.Columns.GetColumnsWidth(DataGridViewElementStates.Displayed) + DGV_Show.RowHeadersWidth + 5

		' Erstelle einen PrintDialog und einen PrintDocument.
		Dim pd As New PrintDialog()
		Dim doc As New Printing.PrintDocument()

		' Setze die Einstellungen des PrintDocument.
		doc.DefaultPageSettings.Landscape = True
		doc.DefaultPageSettings.Margins = New Printing.Margins(10, 10, 10, 10)

		' Füge den PrintDocument zum PrintDialog hinzu.
		pd.Document = doc

		' Zeige den PrintDialog und drucke das DataGridView, wenn der Benutzer "OK" klickt.
		If pd.ShowDialog() = DialogResult.OK Then
			AddHandler doc.PrintPage, AddressOf PrintDocument_PrintPage
			doc.Print()
		End If
	End Sub

	Private Sub PrintDocument_PrintPage(sender As Object, e As Printing.PrintPageEventArgs)
		' Zeichne das DataGridView auf die aktuelle Seite.
		Dim bm As New Bitmap(DGV_Show.Width, DGV_Show.Height)
		DGV_Show.DrawToBitmap(bm, New Rectangle(0, 0, DGV_Show.Width, DGV_Show.Height))
		e.Graphics.DrawImage(bm, e.MarginBounds)
	End Sub



	Private Sub BeendenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles BeendenToolStripMenuItem.Click
		Application.Exit()
	End Sub
End Class
